/* cl aes-demo.c ..\aes.lib */

#include <stdio.h>

typedef struct
{
    unsigned char eks[256];
    unsigned char dks[256];
    int roundn;             
} aes_ctx;

int __stdcall Set_Key(aes_ctx *aes_ctx, char *key, int nbits);
int __stdcall Encrypt(aes_ctx *aes_ctx, char *input, char *output);
int __stdcall SetD_Key(aes_ctx *aes_ctx, char *key, int nbits);
int __stdcall Decrypt(aes_ctx *aes_ctx, char *input, char *output);


int main(int argc, char **argv) {

	aes_ctx ctx;
	unsigned char key[16], buf[16];
	unsigned char input[128]="", output[128]="";
	int i;

	memset(key, 0, 16);

	__asm {
		rdtsc
		mov dword ptr [buf], eax
		bswap eax
		mov dword ptr [buf + 4], eax
		xor eax, edx
		mov dword ptr [buf + 8], eax
		rdtsc
		mov dword ptr [buf + 12], eax
        }
		

	printf("Plaintext      : ");
	for(i=0; i < 16; i++)
		printf("%s%02x", input, buf[i]);

	printf("\n");

	Set_Key(&ctx, key, 128);
	Encrypt(&ctx, buf, buf);

	printf("Encrypted block: ");
	for(i=0; i < 16; i++)
		printf("%s%02x", input, buf[i]);
	printf("\n");

	SetD_Key(&ctx, key, 128);
	Decrypt(&ctx, buf, buf);

	printf("Decrypted block: ");
	for(i=0; i < 16; i++)
		printf("%s%02x", input, buf[i]);
	printf("\n");
	
	return 0;
}